/*******************************************************************************
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 *******************************************************************************/
package org.ow2.orchestra.jaxb.bpmn.marshaller;

import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.xml.XMLConstants;
import javax.xml.bind.Unmarshaller.Listener;
import javax.xml.namespace.QName;
import org.ow2.orchestra.jaxb.bpmn.TExpression;

/**
 * @author Guillaume Porcher
 */
public class ExpressionUnmarshallerListener extends Listener {

  @Override
  public void afterUnmarshal(final Object target, final Object parent) {
    if (target instanceof TExpression) {
      // Transform qname
      List<Object> content = ((TExpression) target).getContent();
      for (Object c : content) {
        if (c instanceof String) {
          Pattern pattern = Pattern.compile("/(.*):");
          Matcher matcher = pattern.matcher((String) c);
          while(matcher.find()) {
            String prefix = matcher.group(1);
            String ns = UnmarshallingContext.getInstance().getNamespaceURI(prefix);
            if (ns != null) {
              ((TExpression) target).getOtherAttributes().put(new QName(XMLConstants.XMLNS_ATTRIBUTE_NS_URI, prefix), ns);
            }
          }
        }
      }
    }
  }
}
